freeslot(
"MT_COSMICCLONE",
"MT_COSMICCLONEFOLLOW",
"S_COSMICCLONESPAWN",
"SKINCOLOR_COSMICCLONE",
"SKINCOLOR_GALAXYCLONE",
"sfx_cspds",
"sfx_cspn",
"sfx_czom",
"sfx_cjmp",
"sfx_cskd",
"sfx_cdril1",
"sfx_cdril2",
"sfx_cdie",
"sfx_cprox",

-- COSMIC MARIO SOUNDS
"sfx_cmpro",
"sfx_cdiv1",
"sfx_cdiv2",
"sfx_cdiv3",
"sfx_cmjmp1",
"sfx_cmjmp2",
"sfx_cmjmp3",
"sfx_cmljp1",
"sfx_cmljp2",
"sfx_cmspn1",
"sfx_cmspn2"
)

-- Console command to allow clones ANYWHERE! have fun :)
rawset(_G, "cosmiccomet", false)

COM_AddCommand("cosmicclonemode", function(player,arg)
	if player.mo and player.mo.valid
		if arg
			if gamestate == GS_LEVEL and G_IsSpecialStage(gamemap) then -- i simply do not want to deal with this
				CONS_Printf(player,"You can't change this during a Special Stage.")
			elseif arg == "on" or arg == "1" or arg == "true" then
				cosmiccomet = true
				print("\x85"+"A Cosmic Comet has landed!")
			elseif arg == "off" or arg == "0" or arg == "false" then
				print("The Cosmic Clones have relented, for now...")
				cosmiccomet = false
				
				-- reset player stuff
				for p in players.iterate do
					if p.mo and p.mo.valid then
						p.mo.clonePositions = {}
					end
					p.cloneTimer = 3*TICRATE
					p.cloneAmount = 0
					p.cloneLast = nil
				end
			else
				CONS_Printf(player,"Invalid Parameter.")
			end
			if arg == nil then
				CONS_Printf(player,"Toggles Cosmic Clones appearing anywhere.")
				CONS_Printf(player,"Options are: on or off")
			end
		end
	end
end, COM_ADMIN)

addHook("NetVars", function(net)
	cosmiccomet = net(cosmiccomet)
end)

skincolors[SKINCOLOR_COSMICCLONE] = {
	name = "Shapeshifting Spacedust",
	ramp = {47, 47, 47, 46, 71, 45, 44, 44, 43, 42, 42, 41, 40, 40, 39, 38},
	invcolor = SKINCOLOR_BLUE,
	invshade = 11,
	chatcolor = V_REDMAP,
	accessible = true}

skincolors[SKINCOLOR_GALAXYCLONE] = {
	name = "Shapeshifting Galaxy",
	ramp = {156, 156, 155, 155, 155, 154, 154, 154, 150, 150, 150, 150, 150, 150, 150, 150},
	invcolor = SKINCOLR_RED,
	invshade = 11,
	chatcolor = V_BLUEMAP,
	accessible = true}

-- Added MF_NOBLOCKMAP and MF_NOCLIPHEIGHT, changed MF_PAIN to MF_SPECIAL
mobjinfo[MT_COSMICCLONE] = {
	spawnstate = S_COSMICCLONESPAWN,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_SPECIAL
}

-- Object used for followmobjs on clones
mobjinfo[MT_COSMICCLONEFOLLOW] = {
	spawnstate = S_INVISIBLE,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

-- Clone spawn state
states[S_COSMICCLONESPAWN] = {
	sprite = SPR_NULL,
	tics = TICRATE,
	nextstate = S_INVISIBLE,
}

-- Clone ambience sound
sfxinfo[sfx_cprox] = {
	flags = SF_NOMULTIPLESOUND,
	caption = "Cosmic Clone"
}

-- Cosmic Mario ambience sound
sfxinfo[sfx_cmpro] = {
	flags = SF_NOMULTIPLESOUND,
	caption = "Cosmic Clone"
}

-- Clone spindash
sfxinfo[sfx_cspds] = {
	caption = "Clone spindash"
}

-- Clone spin
sfxinfo[sfx_cspn] = {
	caption = "Clone spin"
}

-- Clone spin
sfxinfo[sfx_cmspn1] = {
	caption = "Clone spin"
}

-- Clone spin
sfxinfo[sfx_cmspn2] = {
	caption = "Clone spin"
}

-- Clone zoom
sfxinfo[sfx_czom] = {
	caption = "Clone zoom"
}

-- Clone jump
sfxinfo[sfx_cjmp] = {
	caption = "Clone jump"
}

-- Clone jump
sfxinfo[sfx_cmjmp1] = {
	caption = "Clone jump"
}

-- Clone jump
sfxinfo[sfx_cmjmp2] = {
	caption = "Clone jump"
}

-- Clone jump
sfxinfo[sfx_cmjmp3] = {
	caption = "Clone jump"
}

-- Clone jump
sfxinfo[sfx_cmljp1] = {
	caption = "Clone jump"
}

-- Clone jump
sfxinfo[sfx_cmljp2] = {
	caption = "Clone jump"
}

-- Clone dive
sfxinfo[sfx_cdiv1] = {
	caption = "Clone dive"
}

-- Clone dive
sfxinfo[sfx_cdiv2] = {
	caption = "Clone dive"
}

-- Clone dive
sfxinfo[sfx_cdiv3] = {
	caption = "Clone dive"
}

-- Clone skid
sfxinfo[sfx_cskd] = {
	caption = "Clone skid"
}

-- Clone drill
sfxinfo[sfx_cdril1] = {
	caption = "Clone drill"
}

-- Clone drill (loop)
sfxinfo[sfx_cdril2] = {
	caption = "Clone drill"
}

-- Clone die
sfxinfo[sfx_cdie] = {
	caption = "Clone death"
}
		--these are a basis for what the cosmic clones will have in terms of tags.
		--clone.colorized = true
		--clone.color = SKINCOLOR_COSMICCLONE
		--clone.blendmode = AST_SUBTRACT

-- Gets the clone's color to use for various purposes
-- Defaults to SKINCOLOR_COSMICCLONE, but uses the player's skincolor in netgames
local function P_GetCloneColor(clone, player)
	if player and (netgame or multiplayer) then
		return player.skincolor
	end
	return SKINCOLOR_COSMICCLONE
end

-- "Kills" the clone
-- Will actually remove the clone if kill is true
local function P_KillClone(clone, kill, noeffect)
	local player = clone.clonePlayer
	clone.cloneDead = 5*TICRATE -- Keep them "dead" for a while
	-- Stop drawing the clone and its followmobj, and remove MF_SPECIAL
	clone.flags = $ | MF2_DONTDRAW &~ MF_SPECIAL
	if clone.tracer then
		clone.tracer.flags = $ | MF2_DONTDRAW
	end
	-- Death effect
	if not noeffect then
		for i=1, 10 do
			local dust = P_SpawnMobjFromMobj(clone,
			P_RandomRange(clone.radius/FRACUNIT, clone.radius/FRACUNIT)*FRACUNIT,
			P_RandomRange(clone.radius/FRACUNIT, clone.radius/FRACUNIT)*FRACUNIT,
			P_RandomRange(0, clone.height/FRACUNIT)*FRACUNIT, MT_SPINDUST)
			--dust.drawonlyforplayer = player
			dust.color = P_GetCloneColor(clone, clone.clonePlayer)
			dust.colorized = true
			dust.blendmode = AST_SUBTRACT
		end
	end
	
	if kill then
		if clone.tracer then
			P_RemoveMobj(clone.tracer)
		end
		P_RemoveMobj(clone)
		-- Death sound
		if player then
			player.cloneAmount = $ - 1 -- Another clone can spawn
			if not noeffect then
				S_StartSound(player.mo, sfx_cdie, player)
			end
		end
	end
end

-- Handle the player's variables relating to the clones, and actually spawn them
addHook("PlayerThink", function(player)
	-- Cosmic clone skincolor effects for the player
	if player.cloneColor then
		if player.mo.color == SKINCOLOR_COSMICCLONE then
			player.mo.colorized = true
			player.mo.blendmode = AST_SUBTRACT
			-- Dust effect
			if leveltime % 5 == 0 then
				local dust = P_SpawnMobjFromMobj(player.mo,
				P_RandomRange(-player.mo.radius/FRACUNIT, player.mo.radius/FRACUNIT)*FRACUNIT,
				P_RandomRange(-player.mo.radius/FRACUNIT, player.mo.radius/FRACUNIT)*FRACUNIT,
				P_RandomRange(0, player.mo.height/FRACUNIT)*FRACUNIT, MT_SPINDUST)
				dust.color = SKINCOLOR_COSMICCLONE
				dust.colorized = true
				dust.blendmode = AST_SUBTRACT
				dust.scale = $/2
			end
		elseif player.mo.color == SKINCOLOR_GALAXYCLONE then
			player.mo.colorized = true
			player.mo.blendmode = AST_SUBTRACT
			-- Star effect
			if leveltime % 3 == 0 then
				local dust = P_SpawnMobjFromMobj(player.mo,
				P_RandomRange(-player.mo.radius/FRACUNIT, player.mo.radius/FRACUNIT)*FRACUNIT,
				P_RandomRange(-player.mo.radius/FRACUNIT, player.mo.radius/FRACUNIT)*FRACUNIT,
				P_RandomRange(0, player.mo.height/FRACUNIT)*FRACUNIT, MT_BOXSPARKLE)
				dust.color = SKINCOLOR_WHITE
				dust.colorized = true
			end
		else
			player.cloneColor = false
			player.mo.colorized = false
			player.mo.blendmode = 0
		end
	else
		if player.mo.color == SKINCOLOR_COSMICCLONE then
			player.cloneColor = true
		end
		if player.mo.color == SKINCOLOR_GALAXYCLONE then
			player.cloneColor = true
		end
	end
	
	if cosmiccomet == true or (purplecoin == true and G_IsSpecialStage(gamemap) == true) then
		local shouldclone = cosmiccomet
		if (G_IsSpecialStage(gamemap) and player.nightstime <= 0) or player.exiting or player.pflags & PF_FINISHED or player.powers[pw_super]
		or (player.mo.state == S_PLAY_NIGHTS_PULL or player.mo.state == S_PLAY_NIGHTS_ATTACK) then
			shouldclone = false
		elseif gamemap == 56 or gamemap == 57 or gamemap == 66 or (TheRace == "\137Sphere Race") then
			shouldclone = true
		elseif mapheaderinfo[gamemap].typeoflevel&TOL_NIGHTS and (player.nightstime <= (player.startedtime/2)+TICRATE or player.bonustime) then
			shouldclone = true
		elseif mapheaderinfo[gamemap].typeoflevel&~TOL_NIGHTS and player.nightstime <= (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE
			shouldclone = true
		end
		if shouldclone then
			local pmo = player.mo -- I got tired of typing player.mo
			if pmo.clonePositions == nil then
				pmo.clonePositions = {} -- Make the table if it doesn't exist
			end
			-- Lots of stuff to store here: location, skin, angle, spriteroll(for nights), state, frame, scale, followmobj, eflags, super
			-- But first, we need to check for a followmobj
			local followtable = nil
			if player.followmobj then
				local fmo = player.followmobj
				-- We can leave out some of the followmobj's variables and just use the player's
				followtable = {fmo.x, fmo.y, fmo.z, fmo.skin, fmo.state, fmo.frame, fmo.radius, fmo.height, fmo.scale}
			end
			-- followtable will be nil if the player doesn't have a followmobj
			local csuper = false
			if player.powers[pw_super] then
				csuper = true
			end
			table.insert(pmo.clonePositions, {pmo.x, pmo.y, pmo.z, pmo.skin, player.drawangle, pmo.spriteroll, pmo.state, pmo.frame, pmo.scale, followtable, pmo.eflags, csuper})
			if #pmo.clonePositions > TICRATE then
				table.remove(pmo.clonePositions, 1) -- Clones follow 1 second behind, so get rid of stuff from beyond that time
			end
			
			-- Spawn the clone!
			if player.cloneTimer == 0 and player.cloneAmount < 11 then
				player.cloneAmount = $ + 1
				local clone = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_COSMICCLONE) -- Just spawn on the player for now
				--clone.drawonlyforplayer = player -- Only visible to the player they're following
				if not (player.cloneLast and player.cloneLast.valid) then
					clone.target = pmo -- If there are no other clones, target the player
				else
					clone.target = player.cloneLast -- If there are other clones, target the most recent one
				end
				if clone.target then
					player.cloneLast = clone -- New clone becomes the most recent one
					clone.clonePlayer = player -- Keep track of the player
					clone.radius = clone.target.radius
					clone.height = clone.target.height
					clone.colorized = true
					clone.color = P_GetCloneColor(clone, player)
					clone.blendmode = AST_SUBTRACT
					local table = clone.target.clonePositions -- shortcut
					P_SetOrigin(clone, clone.target.x, clone.target.y, clone.target.z) -- move to the target, "spawning" on them
					player.cloneTimer = 3*TICRATE
				end
			end
			if player.cloneTimer > 0 then
				player.cloneTimer = $ - 1
			end
		end
	end
end)

-- Moved this stuff to a PlayerSpawn hook, it's easier and prevents some problems
addHook("PlayerSpawn", function(player)
	--if purplecoin == true and G_IsSpecialStage(gamemap) == true then //checking for this is dumb now, since clones can be enabled whenever
		player.mo.clonePositions = {}
		player.cloneTimer = 3*TICRATE
		player.cloneAmount = 0
		player.cloneLast = nil
	--end
end)

-- Handle Cosmic Clones!
addHook("MobjThinker", function(mobj)
	local player = mobj.clonePlayer
	if not player or (player.mo.state == S_PLAY_NIGHTS_PULL or player.mo.state == S_PLAY_NIGHTS_ATTACK) then
		P_KillClone(mobj, true, mobj.cloneDead)
		return
	end
	if mobj.state == S_COSMICCLONESPAWN then
		-- Cool spawn effect
		local dust = P_SpawnMobjFromMobj(mobj,
		P_RandomRange(-mobj.radius/FRACUNIT, mobj.radius/FRACUNIT)*FRACUNIT,
		P_RandomRange(-mobj.radius/FRACUNIT, mobj.radius/FRACUNIT)*FRACUNIT,
		P_RandomRange(0, mobj.height/FRACUNIT)*FRACUNIT, MT_SPINDUST)
		--dust.drawonlyforplayer = mobj.clonePlayer
		dust.color = P_GetCloneColor(mobj, mobj.clonePlayer)
		dust.colorized = true
		dust.blendmode = AST_SUBTRACT
	else
		if not mobj.target
		or (cosmiccomet == false and not G_IsSpecialStage(gamemap))
		or (G_IsSpecialStage(gamemap) and player.nightstime <= 0)
		or mobj.clonePlayer.exiting or mobj.clonePlayer.pflags & PF_FINISHED or mobj.clonePlayer.powers[pw_super] then
			P_KillClone(mobj, true, mobj.cloneDead)
			return
		end
		
		-- Same table stuff from above
		if mobj.clonePositions == nil then
			mobj.clonePositions = {}
		end
		local followtable = nil
		if mobj.tracer then
			local fmo = mobj.tracer
			followtable = {fmo.x, fmo.y, fmo.z, fmo.skin, fmo.state, fmo.frame, fmo.radius, fmo.height, fmo.scale}
		end
		local csuper = false
		if mobj.eflags&MFE_FORCESUPER then
			csuper = true
		end
		table.insert(mobj.clonePositions, {mobj.x, mobj.y, mobj.z, mobj.skin, mobj.angle, mobj.spriteroll, mobj.state, mobj.frame, mobj.scale, followtable, mobj.eflags, csuper})
		if #mobj.clonePositions > TICRATE then
			table.remove(mobj.clonePositions, 1)
		end
		
		local oldstate = mobj.state -- Used for sounds
		-- Get all the properties from the player/previous clone
		local table = mobj.target.clonePositions
		P_MoveOrigin(mobj, table[1][1], table[1][2], table[1][3])
		mobj.skin = table[1][4]
		mobj.angle = table[1][5]
		mobj.spriteroll = table[1][6]
		mobj.frame = table[1][8] -- setting the state before the frame causes problems, so here we are. why
		mobj.state = table[1][7]
		--mobj.frame = table[1][8]
		mobj.scale = table[1][9]
		mobj.eflags = table[1][11]
		if table[1][12] then
			mobj.eflags = $ | MFE_FORCESUPER
		else
			mobj.eflags = $ &~ MFE_FORCESUPER
		end
		-- If there's a followmobj to make, make it!
		if not mobj.tracer then
			if table[1][10] then
				local clonefollow = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_COSMICCLONEFOLLOW)
				clonefollow.flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
				clonefollow.colorized = true
				clonefollow.color = mobj.color
				clonefollow.blendmode = AST_SUBTRACT
				mobj.tracer = clonefollow
			end
		end
		-- If there is a followmobj, copy it!
		if mobj.tracer then
			local fmo = mobj.tracer
			local ftable = table[1][10]
			if ftable then
				P_SetOrigin(fmo, ftable[1], ftable[2], ftable[3])
				fmo.skin = ftable[4] or "sonic" -- default to sonic because it isn't allowed to be nil
				fmo.angle = mobj.angle
				fmo.spriteroll = mobj.spriteroll
				fmo.frame = ftable[6]
				fmo.state = ftable[5]
				--fmo.frame = ftable[6]
				fmo.radius = ftable[7]
				fmo.height = ftable[8]
				fmo.scale = ftable[9]
				fmo.eflags = mobj.eflags
			else -- Player switched skins? Followmobj died? idk, just kill it
				P_KillMobj(fmo)
			end
		end
		-- If we're dead, should we come back yet?
		if mobj.cloneDead then
			mobj.cloneDead = $-1
			
			if mobj.cloneDead -- stay dead
				mobj.flags = $ | MF2_DONTDRAW &~ MF_SPECIAL
				if mobj.tracer then
					mobj.tracer.flags = $ | MF2_DONTDRAW
				end
			else -- we're so back
				mobj.flags = $ | MF_SPECIAL &~ MF2_DONTDRAW
				if mobj.tracer then
					P_KillMobj(mobj.tracer) -- won't look right when respawning, so just kill it
				end
				mobj.state = S_COSMICCLONESPAWN
				P_SetOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
			end
		else
			-- Dust effect
			if leveltime % 5 == 0 then
				local dust = P_SpawnMobjFromMobj(mobj,
				P_RandomRange(-mobj.radius/FRACUNIT, mobj.radius/FRACUNIT)*FRACUNIT,
				P_RandomRange(-mobj.radius/FRACUNIT, mobj.radius/FRACUNIT)*FRACUNIT,
				P_RandomRange(0, mobj.height/FRACUNIT)*FRACUNIT, MT_SPINDUST)
				dust.color = P_GetCloneColor(mobj, mobj.clonePlayer)
				dust.colorized = true
				dust.blendmode = AST_SUBTRACT
				dust.scale = $/2
			end
			
			-- Cosmic Mario Sound Tables! (my favorite :<)
			local diveSounds = {sfx_cdiv1, sfx_cdiv2, sfx_cdiv3}
			local jumpSounds = {sfx_cmjmp1, sfx_cmjmp2, sfx_cmjmp3}
			local longJumpSounds = {sfx_cmljp1, sfx_cmljp2}
			local spinSounds = {sfx_cmspn1, sfx_cmspn2}
			
			local function GetRandomSound(table)
				return table[P_RandomRange(1, #table)]
			end
			
			-- Sounds!
			
			if mobj.skin == "mario" or mobj.skin == "luigi" then
				S_StartSound(mobj, sfx_cmpro, mobj.clonePlayer) -- Mario Ambience
			else
				S_StartSound(mobj, sfx_cprox, mobj.clonePlayer) -- Ambience
			end
			
			if mobj.state == S_PLAY_SPINDASH and oldstate ~= S_PLAY_SPINDASH then
				if mobj.skin == "mario" or mobj.skin == "luigi" then
					S_StartSound(mobj, GetRandomSound(diveSounds), mobj.clonePlayer)
				else
					S_StartSound(mobj, sfx_cspds, mobj.clonePlayer) -- Spindash start
				end
			elseif mobj.state ~= S_PLAY_SPINDASH and oldstate == S_PLAY_SPINDASH then
				if mobj.skin ~= "mario" and mobj.skin ~= "luigi" then
					S_StartSound(mobj, sfx_czom, mobj.clonePlayer) -- Spindash release
				end
			elseif mobj.state == S_PLAY_ROLL and oldstate ~= S_PLAY_ROLL then
				S_StartSound(mobj, sfx_cspn, mobj.clonePlayer) -- Roll
			elseif mobj.state == S_PLAY_JUMP and oldstate ~= S_PLAY_JUMP then
				if mobj.skin ~= "mario" and mobj.skin ~= "luigi" then
					S_StartSound(mobj, sfx_cjmp, mobj.clonePlayer) -- Jump
				end
			elseif mobj.state == S_PLAY_SKID and oldstate ~= S_PLAY_SKID then
				if mobj.skin ~= "mario" and mobj.skin ~= "luigi" then
					S_StartSound(mobj, sfx_cskd, mobj.clonePlayer) -- Skid
				end
			elseif mobj.state == S_PLAY_NIGHTS_DRILL and oldstate ~= S_PLAY_NIGHTS_DRILL
				S_StartSound(mobj, sfx_cdril1, mobj.clonePlayer) -- Drill start
			elseif mobj.state == S_PLAY_NIGHTS_DRILL
				S_StartSound(mobj, sfx_cdril2, mobj.clonePlayer) -- Drill loop
			elseif mobj.state == S_MARIO_JUMP1 and oldstate ~= S_MARIO_JUMP1 then
				S_StartSound(mobj, GetRandomSound(jumpSounds), mobj.clonePlayer)
			elseif mobj.state == S_MARIO_DOUBLE and oldstate ~= S_MARIO_DOUBLE then
				S_StartSound(mobj, GetRandomSound(jumpSounds), mobj.clonePlayer)
			elseif mobj.state == S_MARIO_TRIPLE and oldstate ~= S_MARIO_TRIPLE then
				S_StartSound(mobj, GetRandomSound(longJumpSounds), mobj.clonePlayer)
			elseif mobj.state == S_MARIO_LONGJUMP and oldstate ~= S_MARIO_LONGJUMP then
				S_StartSound(mobj, GetRandomSound(longJumpSounds), mobj.clonePlayer)
			elseif mobj.state == S_MARIO_BACKFLIP and oldstate ~= S_MARIO_BACKFLIP then
				S_StartSound(mobj, GetRandomSound(jumpSounds), mobj.clonePlayer)
			elseif mobj.state == S_MARIO_SPIN and oldstate ~= S_MARIO_SPIN then
				S_StartSound(mobj, GetRandomSound(spinSounds), mobj.clonePlayer)
			end
		end
	end
end, MT_COSMICCLONE)

-- Cosmic Clones should only damage the player they're copying
addHook("TouchSpecial", function(special, toucher)
	local player = toucher.player
	if special.state ~= S_COSMICCLONESPAWN and special.clonePlayer == player and not player.powers[pw_flashing] then
		P_DamageMobj(toucher, special, special)
		
		-- "kill" the clone
		P_KillClone(special)
		S_StartSound(toucher, sfx_cdie, toucher.player)
		
		if G_IsSpecialStage(gamemap) and player.nightstime <= 0 then
			P_DoPlayerExit(player) -- fix the weird softlock
		end
	end
	return true
end, MT_COSMICCLONE)