local galaxyNumbers = {
	["0"] = "GALAXYNUM0",
	["1"] = "GALAXYNUM1",
	["2"] = "GALAXYNUM2",
	["3"] = "GALAXYNUM3",
	["4"] = "GALAXYNUM4",
	["5"] = "GALAXYNUM5",
	["6"] = "GALAXYNUM6",
	["7"] = "GALAXYNUM7",
	["8"] = "GALAXYNUM8",
	["9"] = "GALAXYNUM9",
}

hud.add(function(v,player)
	local time = player.nightstime/TICRATE
	local clock = v.cachePatch("CLOCKICON")
	
	local rings = 0
	for p in players.iterate do
		rings = $ + p.spheres
	end

	
	local seconds = time % 60
	if seconds < 10 then
		seconds = "0"..$
	end
	-- draw seconds instead of (time % 60)

	local purring = v.cachePatch("PURPC0")
	
	local purplerings = 0
	
	if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and player.capsule and player.capsule.valid then
		purplerings = AngleFixed(player.capsule.angle)/FRACUNIT
	else
		purplerings = mapheaderinfo[gamemap].ssspheres
	end
	
	if purplecoin == true and gamestate == GS_LEVEL and G_IsSpecialStage(gamemap) == true then
		v.drawString(155,185,(time / 60),V_SNAPTOBOTTOM|V_YELLOWMAP,"center")
		v.drawString(160,185,":",V_SNAPTOBOTTOM|V_YELLOWMAP,"center")
		v.drawString(170,185,seconds,V_SNAPTOBOTTOM|V_YELLOWMAP,"center")
		v.drawScaled(140*FRACUNIT,183*FRACUNIT,FRACUNIT/3,clock,V_SNAPTOBOTTOM)
		v.drawScaled(20*FRACUNIT,178*FRACUNIT,FRACUNIT/2,purring,V_FLIP|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		local num = 0
		for p in players.iterate do
			num = $ + p.spheres
		end
		local numstring = tostring(num)
		local numlength = string.len(numstring)
		for i=1, 3 do
			local currentnum = galaxyNumbers["0"]
			if i <= numlength then
				currentnum = galaxyNumbers[string.sub(numstring, numlength+1-i, numlength+1-i)]
			end
			v.drawScaled(65*FRACUNIT - (i*13*FRACUNIT), 163*FRACUNIT, FRACUNIT/2, v.cachePatch(currentnum), V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		end
		--v.drawString(20,170,player.spheres,0,"center")
		if player.bonustime != true then
			v.drawString(70,170,"/",V_SNAPTOBOTTOM|V_SNAPTOLEFT,"center")
			v.drawString(85,170,purplerings,V_SNAPTOBOTTOM|V_SNAPTOLEFT,"center")
		end
	end
end, "game")