-- NiGHTS Purple Ring attraction!

local function P_PurpleRingAttract(ring, dest)
	local dist, speedmul
	if not dest or not dest.health return end
	
	ring.angle = R_PointToAngle2(ring.x, ring.y, dest.x, dest.y)
	dist = P_AproxDistance(P_AproxDistance(dest.x - ring.x, dest.y - ring.y), dest.z - ring.z)
	if dist < 1 then
		dist = 1
	end
	speedmul = P_AproxDistance(dest.momx, dest.momy) + FixedMul(8*FRACUNIT, ring.scale)
	ring.momx = FixedMul(FixedDiv(dest.x - ring.x, dist), speedmul)
	ring.momy = FixedMul(FixedDiv(dest.y - ring.y, dist), speedmul)
	ring.momz = FixedMul(FixedDiv(dest.z - ring.z, dist), speedmul)
end

addHook("MobjThinker", function(mobj)
	if mobj.flags2 & MF2_NIGHTSPULL and mobj.tracer then
		local speedmul = P_AproxDistance(mobj.tracer.momx, mobj.tracer.momy) + 8*FRACUNIT
		P_PurpleRingAttract(mobj, mobj.tracer)
		/*
	else
		-- NiGHTS Helper attraction
		
		for p in players.iterate do
			if not ((netgame or multiplayer) and p.spectator)
			and maptol&TOL_NIGHTS and (p.powers[pw_carry] ~= CR_NIGHTSMODE or p.powers[pw_nights_helper])
				if mobj.flags2 & MF2_NIGHTSPULL then
					continue
				end
				
				if (P_AproxDistance(P_AproxDistance(mobj.x - p.mo.x, mobj.y - p.mo.y), mobj.z - p.mo.z) > FixedMul(128*FRACUNIT, p.mo.scale)) then
					continue
				end
				
				mobj.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT
				mobj.flags2 = $ | MF2_NIGHTSPULL
				mobj.tracer = p.mo
			end
		end
		*/
	end
end, MT_PURPLERING)

-- Basically a recreation of the normal TouchSpecial behavior for MT_NIGHTSLOOPHELPER
addHook("TouchSpecial", function(special, toucher)
	if special.fuse < toucher.fuse - TICRATE then
		if special.target ~= toucher return end
		local x, y, z, count, gatherradius
		count = 1
		x = special.x/FRACUNIT
		y = special.y/FRACUNIT
		z = special.z/FRACUNIT
		for mo in mobjs.iterate() do
			if mo.type ~= MT_NIGHTSLOOPHELPER continue end
			if mo == special continue end
			if mo.target ~= toucher continue end
			if mo.fuse >= special.fuse then
				count = $+1
				x = $ + mo.x/FRACUNIT
				y = $ + mo.y/FRACUNIT
				z = $ + mo.z/FRACUNIT
			end
		end
		x = (x/count)*FRACUNIT
		y = (y/count)*FRACUNIT
		z = (z/count)*FRACUNIT
		gatherradius = P_AproxDistance(P_AproxDistance(special.x - x, special.y - y), special.z - z)
		if toucher.player.powers[pw_nights_superloop] then
			gatherradius = $*2
		end
		if gatherradius < 30*FRACUNIT return end
		
		for mo in mobjs.iterate() do
			if mo.type ~= MT_PURPLERING continue end
			if P_AproxDistance(P_AproxDistance(mo.x - x, mo.y - y), mo.z - z) > gatherradius continue end
			
			mo.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT
			mo.flags2 = $ | MF2_NIGHTSPULL
			mo.tracer = toucher
		end
	end
end, MT_NIGHTSLOOPHELPER)